/*  factors.c -- Find factors of a given number							*
*   Any questions, comments or ideas can be e-mailed to me	*
*   mike_grass@hotmail.com																		*
*																														*
*   Mike Grass																							*/

#define USE_LONGMUL_PATCH
#define USE_LONGDIV_PATCH

#define RETURN_VALUE

#include <all.h>

#define GetLongIntArg(p) \
  ({register unsigned long __n=*(--(ESI)(p)); register unsigned long __s=0; \
  while(__n--) __s=(__s<<8)+*(--(unsigned char*)(p)); (ESI)(p)--; __s;})


int _ti89,_ti92plus;		//Compile for the 89 and 92 plus

void _main(void) 
{
  ESI argptr;							//Declare needed variables
  int bufferIndex=1;			//
  register unsigned long num asm("a5");			//
  unsigned long factor_buffer[500], k=0, sqrtnum;
  short is_square=1;

	if(ArgCount()!=1)
	{
		ERD_process(ArgCount()<1?930:940);
		push_END_TAG();
		push_LIST_TAG();

		return;
	}

/*Initialize some stuff*/
  InitArgPtr(argptr);	//Initialize the argument pointer; needed to get the argument

/*Check that the argument is valid*/
  if(GetArgType(argptr) != POSINT_TAG)
  {
		ERD_process(40);
		push_END_TAG();
		push_LIST_TAG();
		return;
  }

  else  //We have a valid argument, continue execution
  {
    num=(unsigned long)GetLongIntArg(argptr);  //extract the argument into variable num
    push_END_TAG();	//OS works in RPN, so we have to push the END_TAG first
    push_ulong_to_integer(num);	//right now, if num is greater than 2^32/2-1, the calc will wrap the number around to negative numbers :(
    
    sqrtnum = trunc(sqrt(flt(num)));
    if(sqrtnum==0 && num!=0)
    {
    	sqrtnum = (unsigned long)num/2;
    }
/*    sprintf(string,"%lu",sqrtnum);
    ST_helpMsg(string);
    ngetchx(); */
    for(k=2; k<=sqrtnum; k++)		//k should never reach num (unless num is 1 or 2)
		{

    	if(num % k == 0)		//check if k is a factor of num
			{

				if(bufferIndex>1)	//make sure that we aren't causing an error
				{

	  			if((factor_buffer[bufferIndex-1]*k)==num)	//if previous found factor * current factor == num,
	  			{						//we have found the midpoint and don't need to

	    			break;					//keep searching for factors, because all of 

	  			}						//the rest of the factors will be

				}						//num/factor_buffer[k] from current k to 1

				factor_buffer[bufferIndex]=k;  //add the current factor to the buffer
				bufferIndex+=1;		//update the buffer index

				if(k*k==num)    //check to see if k^2==num, we are at the midpoint of factors
				{
				//	bufferIndex-=1;
					is_square=2;
	  			break;
				}

      }

    }

/*Find the other factors from the factor_buffer by dividing num by factor_buffer[k]*/

   for(k=bufferIndex-is_square;k>=1;k--)  
   {
     factor_buffer[bufferIndex++]=num/factor_buffer[k];
   }
   for(k=bufferIndex-1;k>=1;k--)
   {
     push_ulong_to_integer(factor_buffer[k]);
   }
   push_ulong_to_integer(1);	//all integers have factors of 1
   push_LIST_TAG();//tell the OS that we have pushed a list on the stack
 }
 return;  
}
